#!/bin/bash

ffoo import core

assert_linecount() {
    #
    # Assert that count of lines in $1 is $2
    #
    local ex file num
    file="$1"; shift;
    ex="$@"
    case $ex in
        [0-9]*) ex="-eq $ex" ;;
        -*)     true         ;;
        *)      usage_is "FILE EXPR" \
                         "FILE NUM" ;;
    esac
    test 0$(wc -l <$file) $ex
}

collect_artifacts() {
    #
    # Collect everything that is registered as artifact
    #
    local aroot="$1"
    test -n "$aroot" || usage_is "target_root"
    test -f $FFOO_TMP/artifact_list || return 0
    local tgt
    think "collecting artifacts to $aroot"
    cat $FFOO_TMP/artifact_list \
        | while read path;
          do
              tgt=$aroot/$(dirname $path)
              mkdir -p $tgt
              cp -r "$path" "$tgt"
          done
}

register_artifact() {
    #
    # Register artifact path for later collection
    #
    test -n "$FFOO_TMP" && FFOO_TMP=$(mktemp -d)
    local list=$FFOO_TMP/artifact_list
    local a
    for a in "$@";
    do
        local dn=$(cd $(dirname $a); pwd)
        test "$dn" = "/" && dn=""   # hack: avoid "//" if path was abs
        local abspath="$dn/$(basename $a)"
        think "registering artifact $abspath"
        append_if_missing  "$abspath" $list
    done
}
